// This file is generated by kconfig_compiler_kf5 from konsole.kcfg.
// All changes you do to this file will be lost.
#ifndef KONSOLE_KONSOLESETTINGS_H
#define KONSOLE_KONSOLESETTINGS_H

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

namespace Konsole {

class KonsoleSettings : public KConfigSkeleton
{
  public:
    enum EnumTabBarVisibility { AlwaysShowTabBar, ShowTabBarWhenNeeded, AlwaysHideTabBar };
    enum EnumTabBarPosition { Top, Bottom };
    enum EnumNewTabBehavior { PutNewTabAtTheEnd, PutNewTabAfterCurrentTab };

    static KonsoleSettings *self();
    ~KonsoleSettings();

    /**
      Set Show menubar by default
    */
    static
    void setShowMenuBarByDefault( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowMenuBarByDefault" ) ))
        self()->mShowMenuBarByDefault = v;
    }

    /**
      Get Show menubar by default
    */
    static
    bool showMenuBarByDefault()
    {
      return self()->mShowMenuBarByDefault;
    }

    /**
      Get Item object corresponding to ShowMenuBarByDefault()
    */
    ItemBool *showMenuBarByDefaultItem()
    {
      return mShowMenuBarByDefaultItem;
    }

    /**
      Set Show window title on the titlebar
    */
    static
    void setShowWindowTitleOnTitleBar( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowWindowTitleOnTitleBar" ) ))
        self()->mShowWindowTitleOnTitleBar = v;
    }

    /**
      Get Show window title on the titlebar
    */
    static
    bool showWindowTitleOnTitleBar()
    {
      return self()->mShowWindowTitleOnTitleBar;
    }

    /**
      Get Item object corresponding to ShowWindowTitleOnTitleBar()
    */
    ItemBool *showWindowTitleOnTitleBarItem()
    {
      return mShowWindowTitleOnTitleBarItem;
    }

    /**
      Set Show "- Konsole" on the titlebar
    */
    static
    void setShowAppNameOnTitleBar( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowAppNameOnTitleBar" ) ))
        self()->mShowAppNameOnTitleBar = v;
    }

    /**
      Get Show "- Konsole" on the titlebar
    */
    static
    bool showAppNameOnTitleBar()
    {
      return self()->mShowAppNameOnTitleBar;
    }

    /**
      Get Item object corresponding to ShowAppNameOnTitleBar()
    */
    ItemBool *showAppNameOnTitleBarItem()
    {
      return mShowAppNameOnTitleBarItem;
    }

    /**
      Set Enable menu accelerators
    */
    static
    void setAllowMenuAccelerators( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "AllowMenuAccelerators" ) ))
        self()->mAllowMenuAccelerators = v;
    }

    /**
      Get Enable menu accelerators
    */
    static
    bool allowMenuAccelerators()
    {
      return self()->mAllowMenuAccelerators;
    }

    /**
      Get Item object corresponding to AllowMenuAccelerators()
    */
    ItemBool *allowMenuAcceleratorsItem()
    {
      return mAllowMenuAcceleratorsItem;
    }

    /**
      Set Show hint for terminal size after resizing
    */
    static
    void setShowTerminalSizeHint( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowTerminalSizeHint" ) ))
        self()->mShowTerminalSizeHint = v;
    }

    /**
      Get Show hint for terminal size after resizing
    */
    static
    bool showTerminalSizeHint()
    {
      return self()->mShowTerminalSizeHint;
    }

    /**
      Get Item object corresponding to ShowTerminalSizeHint()
    */
    ItemBool *showTerminalSizeHintItem()
    {
      return mShowTerminalSizeHintItem;
    }

    /**
      Set Use current window size on next startup
    */
    static
    void setSaveGeometryOnExit( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "SaveGeometryOnExit" ) ))
        self()->mSaveGeometryOnExit = v;
    }

    /**
      Get Use current window size on next startup
    */
    static
    bool saveGeometryOnExit()
    {
      return self()->mSaveGeometryOnExit;
    }

    /**
      Get Item object corresponding to SaveGeometryOnExit()
    */
    ItemBool *saveGeometryOnExitItem()
    {
      return mSaveGeometryOnExitItem;
    }

    /**
      Set Control the visibility of the whole tab bar
    */
    static
    void setTabBarVisibility( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "TabBarVisibility" ) ))
        self()->mTabBarVisibility = v;
    }

    /**
      Get Control the visibility of the whole tab bar
    */
    static
    int tabBarVisibility()
    {
      return self()->mTabBarVisibility;
    }

    /**
      Get Item object corresponding to TabBarVisibility()
    */
    ItemEnum *tabBarVisibilityItem()
    {
      return mTabBarVisibilityItem;
    }

    /**
      Set Control the position of the tab bar
    */
    static
    void setTabBarPosition( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "TabBarPosition" ) ))
        self()->mTabBarPosition = v;
    }

    /**
      Get Control the position of the tab bar
    */
    static
    int tabBarPosition()
    {
      return self()->mTabBarPosition;
    }

    /**
      Get Item object corresponding to TabBarPosition()
    */
    ItemEnum *tabBarPositionItem()
    {
      return mTabBarPositionItem;
    }

    /**
      Set Control the visual style of the tab bar
    */
    static
    void setTabBarStyleSheet( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "TabBarStyleSheet" ) ))
        self()->mTabBarStyleSheet = v;
    }

    /**
      Get Control the visual style of the tab bar
    */
    static
    QString tabBarStyleSheet()
    {
      return self()->mTabBarStyleSheet;
    }

    /**
      Get Item object corresponding to TabBarStyleSheet()
    */
    ItemString *tabBarStyleSheetItem()
    {
      return mTabBarStyleSheetItem;
    }

    /**
      Set Use a user-defined .css file for the tab bar
    */
    static
    void setTabBarUseUserStyleSheet( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "TabBarUseUserStyleSheet" ) ))
        self()->mTabBarUseUserStyleSheet = v;
    }

    /**
      Get Use a user-defined .css file for the tab bar
    */
    static
    bool tabBarUseUserStyleSheet()
    {
      return self()->mTabBarUseUserStyleSheet;
    }

    /**
      Get Item object corresponding to TabBarUseUserStyleSheet()
    */
    ItemBool *tabBarUseUserStyleSheetItem()
    {
      return mTabBarUseUserStyleSheetItem;
    }

    /**
      Set The .css file to use for the tab bar style
    */
    static
    void setTabBarUserStyleSheetFile( const QUrl & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "TabBarUserStyleSheetFile" ) ))
        self()->mTabBarUserStyleSheetFile = v;
    }

    /**
      Get The .css file to use for the tab bar style
    */
    static
    QUrl tabBarUserStyleSheetFile()
    {
      return self()->mTabBarUserStyleSheetFile;
    }

    /**
      Get Item object corresponding to TabBarUserStyleSheetFile()
    */
    ItemUrl *tabBarUserStyleSheetFileItem()
    {
      return mTabBarUserStyleSheetFileItem;
    }

    /**
      Set Control the visibility of quick buttons on the tab bar
    */
    static
    void setShowQuickButtons( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowQuickButtons" ) ))
        self()->mShowQuickButtons = v;
    }

    /**
      Get Control the visibility of quick buttons on the tab bar
    */
    static
    bool showQuickButtons()
    {
      return self()->mShowQuickButtons;
    }

    /**
      Get Item object corresponding to ShowQuickButtons()
    */
    ItemBool *showQuickButtonsItem()
    {
      return mShowQuickButtonsItem;
    }

    /**
      Set Control where to put the new tab
    */
    static
    void setNewTabBehavior( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "NewTabBehavior" ) ))
        self()->mNewTabBehavior = v;
    }

    /**
      Get Control where to put the new tab
    */
    static
    int newTabBehavior()
    {
      return self()->mNewTabBehavior;
    }

    /**
      Get Item object corresponding to NewTabBehavior()
    */
    ItemEnum *newTabBehaviorItem()
    {
      return mNewTabBehaviorItem;
    }

    /**
      Set Printer &friendly mode (black text, no background)
    */
    static
    void setPrinterFriendly( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "PrinterFriendly" ) ))
        self()->mPrinterFriendly = v;
    }

    /**
      Get Printer &friendly mode (black text, no background)
    */
    static
    bool printerFriendly()
    {
      return self()->mPrinterFriendly;
    }

    /**
      Get Item object corresponding to PrinterFriendly()
    */
    ItemBool *printerFriendlyItem()
    {
      return mPrinterFriendlyItem;
    }

    /**
      Set &Scale output
    */
    static
    void setScaleOutput( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ScaleOutput" ) ))
        self()->mScaleOutput = v;
    }

    /**
      Get &Scale output
    */
    static
    bool scaleOutput()
    {
      return self()->mScaleOutput;
    }

    /**
      Get Item object corresponding to ScaleOutput()
    */
    ItemBool *scaleOutputItem()
    {
      return mScaleOutputItem;
    }

  protected:
    KonsoleSettings();
    friend class KonsoleSettingsHelper;


    // KonsoleWindow
    bool mShowMenuBarByDefault;
    bool mShowWindowTitleOnTitleBar;
    bool mShowAppNameOnTitleBar;
    bool mAllowMenuAccelerators;
    bool mShowTerminalSizeHint;
    bool mSaveGeometryOnExit;

    // TabBar
    int mTabBarVisibility;
    int mTabBarPosition;
    QString mTabBarStyleSheet;
    bool mTabBarUseUserStyleSheet;
    QUrl mTabBarUserStyleSheetFile;
    bool mShowQuickButtons;
    int mNewTabBehavior;

    // PrintOptions
    bool mPrinterFriendly;
    bool mScaleOutput;

  private:
    ItemBool *mShowMenuBarByDefaultItem;
    ItemBool *mShowWindowTitleOnTitleBarItem;
    ItemBool *mShowAppNameOnTitleBarItem;
    ItemBool *mAllowMenuAcceleratorsItem;
    ItemBool *mShowTerminalSizeHintItem;
    ItemBool *mSaveGeometryOnExitItem;
    ItemEnum *mTabBarVisibilityItem;
    ItemEnum *mTabBarPositionItem;
    ItemString *mTabBarStyleSheetItem;
    ItemBool *mTabBarUseUserStyleSheetItem;
    ItemUrl *mTabBarUserStyleSheetFileItem;
    ItemBool *mShowQuickButtonsItem;
    ItemEnum *mNewTabBehaviorItem;
    ItemBool *mPrinterFriendlyItem;
    ItemBool *mScaleOutputItem;
};

}

#endif

